package ru.ulstu.tsMethods.exponential;

import ru.ulstu.models.Forecast;
import ru.ulstu.models.Model;
import ru.ulstu.models.TimeSeries;
import ru.ulstu.tsMethods.TimeSeriesMethod;

public class NoTrendNoSeason extends TimeSeriesMethod {
    private double alpha;

    public NoTrendNoSeason(double alpha) {
        this.alpha = alpha;
    }

    @Override
    protected Model getModelOfValidTimeSeries(TimeSeries timeSeries) {
        Model model = new Model(timeSeries);
        model.addValue(timeSeries.getFirstValue());
        //выполняется проход модели по сглаживанию
        for (int t = 1; t < timeSeries.getValues().size(); t++) {
            model.addValue(timeSeries.getValues().get(t),
                    (1 - alpha) * timeSeries.getNumericValue(t)
                            + alpha * model.getModelTimeSeries().getValues().get(t - 1).getValue());
        }
        return model;
    }

    @Override
    protected Forecast makeForecast(Forecast forecast) {
        forecast.getForecastTimeSeries()
                .getFirstValue()
                .setValue(forecast.getModel().getModelTimeSeries().getLastValue().getValue());
        for (int t = 1; t < forecast.getForecastTimeSeries().getLength(); t++) {
            forecast.getForecastTimeSeries()
                    .getValues()
                    .get(t)
                    .setValue(alpha * forecast.getForecastTimeSeries().getValues().get(t - 1).getValue());
        }
        return forecast;
    }

/*    public NoTrendNoSeason(TimeSeries originalTimeSeries) throws TimeSeriesValidateException {
        super(originalTimeSeries);
        model.addValue(originalTimeSeries.getValues().get(0));
        forecast.addValue(originalTimeSeries.getValues().get(0));
        parameters.put(Param.ALPHA, 1.0);
    }

    public void setAlpa(double value) {
        parameters.put(Param.ALPHA, value);
    }

    @Override
    public void createModel() {
        double e;

        //выполняется проход модели по сглаживанию и прогнозированию countPointForecast точек
        for (int t = 0; t < originalTimeSeries.getValues().size() - 1 + countForecast; t++) {
            // пока не дошли до конца ряда - сглаживаем, иначе строим прогноз
            if (t < originalTimeSeries.getValues().size()) {
                e = originalTimeSeries.getValues().get(t).getValue() - forecast.getForecast().getValues().get(t).getValue();
            } else {
                e = 0;
            }
            model.addValue(model.getModelTimeSeries().getLastValue(),
                    model.getModelTimeSeries().getValues().get(t).getValue() + parameters.get(Param.ALPHA) * e);    //  уровень
            forecast.addValue(model.getModelTimeSeries().getLastValue());        //  прогноз
        }
    }
 */
}
